#!/bin/zsh
set -e

branch=${PLUGIN_BRANCH:-"pages"}
token_env=${PLUGIN_TOKEN_ENV}
output=${PLUGIN_OUTPUT}
name=${PLUGIN_NAME}
email=${PLUGIN_EMAIL}
if [[ -z "$token_env" || -z "$branch" || -z "$name" || -z "$email" ]]; then
    echo "Invalid configuration: Token environment variable name, branch name empty, name, or email"
    exit 1
fi

# Setup the SSH directory
mkdir -p ~/.ssh
chown root:root ~/.ssh
chmod 700 ~/.ssh

# Setup the SSH key
print -rl -- ${(P)token_env} > ~/.ssh/id_rsa
chown root:root ~/.ssh/id_rsa
chmod 600 ~/.ssh/id_rsa

# Setup git
git config --global user.email "$email"
git config --global user.name "$name"
git config --global --add safe.directory "$CI_WORKSPACE/$CI_REPO_OWNER/$CI_REPO_NAME/$output"

# Init a new repository in the output directory and add all files
git init -b "$branch" "$output"
cd "$output"
git add --all
git commit -m "Deploy new version $CI_COMMIT_SHA"

# Push the repository
git push -u "$CI_REPO_CLONE_SSH_URL" -f "$branch"